<?php
/*
 * @package userport
 * @copyright 2008-2011 Parvus
 * @license http://www.gnu.org/licenses/gpl-3.0.html
 * @link http://joomlacode.org/gf/project/userport/
 * @author Parvus
 *
 * userport is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free
 * Software Foundation, either version 3 of the License, or (at your option)
 * any later version.
 *
 * userport is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
 * more details.
 *
 * You should have received a copy of the GNU General Public License along
 * with userport. If not, see <http://www.gnu.org/licenses/>.
 */
defined( '_JEXEC' ) or die( 'Restricted access' );

class JUserportHtml
{
  function ShowExportedUsers( $option, $task, & $userList )
  {
    JUserportHtml::ShowTextarea( $option, $task, JText::_( 'LABEL_EXPORTED_USERS' ), $userList );
  }

  function ShowTextarea( $option, $task, $title, & $userList )
  {
    ?>
    <fieldset class="adminForm">
      <legend><?php echo $title; ?></legend>
      <?php if ( $task != 'export' )
      {
        echo JText::sprintf( 'HELP_EDIT',
            implode( ', ', JUserportHelper::Fields( 'import' ) ),
            'username, email',
            'username',
            implode( ', ', JUserportHelper::UserTypes() ) );
      } ?>
      <label for="user_list"><?php echo JText::_( 'LABEL_CSV_EDIT_TEXT' ) ?></label>
      <form action="index.php" method="post" name="adminForm">
        &nbsp;
        <textarea class="text_area" name="user_list" id="user_list" cols="128" rows="32"><?php
          echo $userList;
        ?></textarea>
        <input type="hidden" name="option" value="<?php echo $option; ?>" />
        <input type="hidden" name="task" value="" />
      </form>
    </fieldset>
    <?php
  }

  function ShowEndResult( $option, $task, $settings )
  {
    JUserportHtml::DummyForm( $option, $task, $settings );
  }

  function DummyForm( $option, $task, $settings = null )
  {
    /* If no form with the name adminForm is present, the toolbarbuttons do
     * not work - except for the back button, which is nothing more than
     * javascript:history.back();
     */
    ?>
    <form action="index.php" method="post" name="adminForm">
      <input type="hidden" name="option" value="<?php echo $option; ?>" />
      <input type="hidden" name="task" value="" />
      <?php if ( $settings ): ?>
        <?php foreach( $settings as $key => $value ): ?>
          <input type="hidden" name="<?php echo $key; ?>" value="<?php echo $value; ?>" />
        <?php endforeach; ?>
      <?php endif; ?>
    </form>
    <?php
  }

  function ShowChooseInitialTextForm( $option, $task, $title, $settings, $showRemoveQuotesOption = false )
  {
    ?>
    <fieldset class="adminForm">
      <legend><?php echo $title; ?></legend>
      <form action="index.php" method="post" id="adminForm" name="adminForm" enctype="multipart/form-data">

        <?php if ( JString::strpos( $task, 'export' ) === FALSE ): ?>
          <p>
            <input type="radio" name="initial_text" id="empty" value="empty" />
            <label for="empty"><?php echo JText::_( 'LABEL_EMPTY_INITIAL_TEXT' ) ?></label>
            <br /><br />
          </p>
          <p>
            <input type="radio" name="initial_text" id="file" value="file" />
            <label for="file"><?php echo JText::_( 'LABEL_FILE_CONTENTS_AS_INITIAL_TEXT' ) ?></label>
            <input type="file" size="80" name="file_upload" id="file_upload" />
            <label for="file"><?php echo JText::sprintf( 'INFO_EXAMPLE_FILE', 'components/com_userport/images/' . ($showRemoveQuotesOption ? 'exampleA.txt' : 'example1.txt' )) ?></label>
            <?php if ( $showRemoveQuotesOption ): ?>
              <br />
              <?php
                $yesOption = '';
                $noOption = 'selected';
              ?>
              &nbsp;
              <label for="remove_quotes"><?php echo JText::_( 'LABEL_REMOVE_QUOTES' ) ?></label>
              <select name="remove_quotes">
                <option value="0" <?php echo $noOption; ?>><?php echo JText::_( 'NO' ) ?></option>
                <option value="1" <?php echo $yesOption; ?>><?php echo JText::_( 'YES' ) ?></option>
              </select>
            <?php endif; ?>
            <br /><br />
          </p>
        <?php endif; ?>
        <p>
          <input type="radio" name="initial_text" id="current_users" value="current_users" checked />
          <label for="current_users"><?php echo JText::_( 'LABEL_CURRENT_USERS_AS_CSV_TEXT' ) ?></label>
          <br />
          <?php
            $commaOption = '';
            $semicolonOption = 'selected';
            $tabOption = '';
          ?>
          &nbsp;
          <label for="field_separator"><?php echo JText::_( 'LABEL_FIELD_SEPARATOR' ) ?></label>
          <select name="field_separator">
            <option value="," <?php echo $commaOption; ?>><?php echo JText::_( 'LABEL_OPTION_COMMA_AS_FIELD_SEPARATOR' ) ?></option>
            <option value=";" <?php echo $semicolonOption; ?>><?php echo JText::_( 'LABEL_OPTION_SEMI_COLON_AS_FIELD_SEPARATOR' ) ?></option>
            <option value="tab" <?php echo $tabOption; ?>><?php echo JText::_( 'LABEL_OPTION_TAB_AS_FIELD_SEPARATOR' ) ?></option>
          </select>
          <br />
          <?php
            $basicOption = '';
            $importOption = 'selected';
            $allOption = '';
          ?>
          &nbsp;
          <label for="which_fields"><?php echo JText::_( 'LABEL_EXPORT_WHICH_FIELDS' ) ?></label>
          <select name="which_fields">
            <option value="basic" <?php echo $basicOption; ?>><?php echo JText::_( 'LABEL_OPTION_EXPORT_BASIC_FIELDS' ) ?></option>
            <option value="import" <?php echo $importOption; ?>><?php echo JText::_( 'LABEL_OPTION_EXPORT_IMPORT_FIELDS' ) ?></option>
            <option value="all" <?php echo $allOption; ?>><?php echo JText::_( 'LABEL_OPTION_EXPORT_ALL_FIELDS' ) ?></option>
          </select>
          <br />
          <?php
            $yesOption = '';
            $noOption = '';
            $defaultOption = 'selected';
          ?>
          &nbsp;
          <label for="block"><?php echo JText::_( 'LABEL_EXPORT_FILTER' ) ?></label>
          <select name="block">
            <option value="0" <?php echo $noOption; ?>><?php echo JText::_( 'LABEL_OPTION_EXPORT_NON_BLOCKED_USERS' ) ?></option>
            <option value="1" <?php echo $yesOption; ?>><?php echo JText::_( 'LABEL_OPTION_EXPORT_BLOCKED_USERS' ) ?></option>
            <option value="default" <?php echo $defaultOption; ?>><?php echo JText::_( 'LABEL_OPTION_EXPORT_BLOCKED_AND_NON_BLOCKED_USERS' ) ?></option>
          </select>
          <?php
            $andOption = '';
            $orOption = 'selected';
          ?>
          &nbsp;
          <select name="filter_combination">
            <option value="and" <?php echo $andOption; ?>><?php echo JText::_( 'LABEL_OPTION_FILTER_USING_AND' ) ?></option>
            <option value="or" <?php echo $orOption; ?>><?php echo JText::_( 'LABEL_OPTION_FILTER_USING_OR' ) ?></option>
          </select>
          <?php
            $yesOption = '';
            $noOption = '';
            $defaultOption = 'selected';
          ?>
          &nbsp;
          <select name="non_activated">
            <option value="0" <?php echo $noOption; ?>><?php echo JText::_( 'LABEL_OPTION_EXPORT_ACTIVATED_USERS' ) ?></option>
            <option value="1" <?php echo $yesOption; ?>><?php echo JText::_( 'LABEL_OPTION_EXPORT_NON_ACTIVATED_USERS' ) ?></option>
            <option value="default" <?php echo $defaultOption; ?>><?php echo JText::_( 'LABEL_OPTION_EXPORT_ACTIVATED_AND_NON_ACTIVATED_USERS' ) ?></option>
          </select>
        </p>

        <input type="hidden" name="option" value="<?php echo $option; ?>" />
        <input type="hidden" name="task" value="" />
      </form>
    </fieldset>
    <?php
  }

  /**
   * Shows a form in which the user can select further options that affect
   * the pending task.
   * @param $option string Joomla terminology for the component that is
   * currently run
   * @param $task string The pending task.
   * @param $title string The title to use for the form.
   * @param $settings dict A named array, containing the useful settings;
   * including the contents of the csv editor on which the task
   * must be applied.
   * @return void
   */
  function ShowOptions( $option, $task, $title, $settings )
  {
    switch ($task)
    {
      case 'show-options-for-add':
        JUserportHtml::_ShowAddOptions( $option, $title, $settings );
        break;

      case 'show-options-for-update':
        JUserportHtml::_ShowUpdateOptions( $option, $title, $settings );
        break;

      case 'show-options-for-delete':
        JUserportHtml::_ShowDeleteOptions( $option, $title, $settings );
        break;

      default:
        /// TODO add message to app message queue
        /// TODO add redirect
        break;
    }
  }

  /**
   * Private function. Only to be called via userportShowOptions. Creates
   * the form with specific options for adding users.
   * @param $option string The $option argument from userportShowOptions
   * @param $title string The $title argument from userportShowOptions
   * @param $settings dict A named array. The $settings argument from userportShowOptions
   * @return void
   * @access private
   */
  function _ShowAddOptions( $option, $title, $settings )
  {
    ?>
    <fieldset class="adminForm">
      <legend><?php echo $title; ?></legend>
      <form action="index.php" method="post" name="adminForm">
        <p>
          <?php
            $yesOption = $settings[ 'auto_generate_passwords' ] ? 'checked' : '';
            $noOption = $settings[ 'auto_generate_passwords' ] ? '' : 'checked';
          ?>
          <label><?php echo JText::_( 'LABEL_ADD_OPTION_AUTO_GENERATE_PASSWORDS' ) ?></label>
          <input type="radio" name="auto_generate_passwords" id="auto_generate_passwords_yes" value="1" <?php echo $yesOption; ?>/>
          <label for="auto_generate_passwords_yes"><?php echo JText::_( 'YES' ) ?></label>
          <input type="radio" name="auto_generate_passwords" id="auto_generate_passwords_no" value="0" <?php echo $noOption; ?> />
          <label for="auto_generate_passwords_no"><?php echo JText::_( 'NO' ) ?></label>
        </p>
        <?php echo JUserportHtml::_ShowGeneralOptions( $settings ) ?>

        <input type="hidden" name="user_list" value="<?php echo urlencode( $settings[ 'user_list' ] ); ?>" />
        <input type="hidden" name="option" value="<?php echo $option; ?>" />
        <input type="hidden" name="task" value="" />
      </form>
    </fieldset>
    <?php
  }

  /**
   * Private function. Only to be called via userportShowOptions. Creates
   * the form with specific options for updating users.
   * @param $option string The $option argument from userportShowOptions
   * @param $title string The $title argument from userportShowOptions
   * @param $settings dict A named array. The $settings argument from userportShowOptions
   * @return void
   * @access private
   */
  function _ShowUpdateOptions( $option, $title, $settings )
  {
    ?>
    <fieldset class="adminForm">
      <legend><?php echo $title; ?></legend>
      <form action="index.php" method="post" name="adminForm">
        <p>
          <?php
            $yesOption = $settings[ 'overwrite_password' ] ? 'checked' : '';
            $noOption = $settings[ 'overwrite_password' ] ? '' : 'checked';
          ?>
          <label><?php echo JText::_( 'LABEL_UPDATE_OPTION_OVERWRITE_PASSWORD' ) ?></label>
          <input type="radio" name="overwrite_password" id="overwrite_password_yes" value="1" <?php echo $yesOption; ?>/>
          <label for="overwrite_password_yes"><?php echo JText::_( 'YES' ) ?></label>
          <input type="radio" name="overwrite_password" id="overwrite_password_no" value="0" <?php echo $noOption; ?> />
          <label for="overwrite_password_no"><?php echo JText::_( 'NO' ) ?></label>
        </p>
        <?php echo JUserportHtml::_ShowGeneralOptions( $settings ) ?>

        <input type="hidden" name="user_list" value="<?php echo urlencode( $settings[ 'user_list' ] ); ?>" />
        <input type="hidden" name="option" value="<?php echo $option; ?>" />
        <input type="hidden" name="task" value="" />
      </form>
    </fieldset>
    <?php
  }

  /**
   * Private function. Only to be called via userportShowOptions. Creates
   * the form with specific options for deleting users.
   * @param $option string The $option argument from userportShowOptions
   * @param $title string The $title argument from userportShowOptions
   * @param $settings dict A named array. The $settings argument from userportShowOptions
   * @return void
   * @access private
   */
  function _ShowDeleteOptions( $option, $title, $settings )
  {
    ?>
    <fieldset class="adminForm">
      <legend><?php echo $title; ?></legend>
      <form action="index.php" method="post" name="adminForm">
        <p>
          <label><?php echo JText::_( 'LABEL_DELETE_OPTION_CONFIRM' ) ?></label>
          <input type="radio" name="confirmation1" id="confirm_1_yes" value="1" />
          <label for="confirm_1_yes"><?php echo JText::_( 'YES' ) ?></label>
          <input type="radio" name="confirmation1" id="confirm_1_no" value="0" checked />
          <label for="confirm_1_no"><?php echo JText::_( 'NO' ) ?></label>
        </p>
        <p>
          <label><?php echo JText::_( 'LABEL_DELETE_OPTION_CONFIRM' ) ?></label>
          <input type="radio" name="confirmation2" id="confirm_2_yes" value="1" />
          <label for="confirm_2_yes"><?php echo JText::_( 'YES' ) ?></label>
          <input type="radio" name="confirmation2" id="confirm_2_no" value="0" checked />
          <label for="confirm_2_no"><?php echo JText::_( 'NO' ) ?></label>
        </p>
        <p>
          <label><?php echo JText::_( 'LABEL_DELETE_OPTION_CONFIRM' ) ?></label>
          <input type="radio" name="confirmation3" id="confirm_3_yes" value="1" />
          <label for="confirm_3_yes"><?php echo JText::_( 'YES' ) ?></label>
          <input type="radio" name="confirmation3" id="confirm_3_no" value="0" checked />
          <label for="confirm_3_no"><?php echo JText::_( 'NO' ) ?></label>
        </p>
        <?php echo JUserportHtml::_ShowGeneralOptions( $settings, array( 'notify_user', 'dry_run' ) ) ?>

        <input type="hidden" name="user_list" value="<?php echo urlencode( $settings[ 'user_list' ] ); ?>" />
        <input type="hidden" name="option" value="<?php echo $option; ?>" />
        <input type="hidden" name="task" value="" />
      </form>
    </fieldset>
    <?php
  }

  /**
   * Private function. Only to be called via _userportShow.+Options. Adds
   * general options to the form currently being created.
   * Assumes the form open tag has been printed, but not the form end tag.
   * Will add complete paragraphs.
   * @param $settings dict A named array. The $settings argument from userportShowOptions
   * @param $options array - May not be Null. When empty, all general options are shown.
   * Else, only the options listed in the array values.
   * @return void
   * @access private
   */
  function _ShowGeneralOptions( $settings, $options = array() )
  {
    ?>
    <?php if ( ( count( $options ) == 0) or in_array( 'passwords_are_encoded', $options ) ): ?>
      <p>
        <?php
          $yesOption = $settings[ 'passwords_are_encoded' ] ? 'checked' : '';
          $noOption = $settings[ 'passwords_are_encoded' ] ? '' : 'checked';
          ?>
        <label><?php echo JText::_( 'LABEL_OPTION_PASSWORDS_ARE_ENCODED' ) ?></label>
        <input type="radio" name="passwords_are_encoded" id="passwords_are_encoded_yes" value="1" <?php echo $yesOption; ?>/>
        <label for="passwords_are_encoded_yes"><?php echo JText::_( 'YES' ) ?></label>
        <input type="radio" name="passwords_are_encoded" id="passwords_are_encoded_no" value="0" <?php echo $noOption; ?> />
        <label for="passwords_are_encoded_no"><?php echo JText::_( 'NO' ) ?></label>
      </p>
    <?php endif; ?>
    <?php if ( ( count( $options ) == 0) or in_array( 'usertype', $options ) ): ?>
      <p>
        <?php
          $registeredOption = '';
          $authorOption = '';
          $editorOption = '';
          $publisherOption = '';
          $userTypeDefaultOption = '';
          switch ( $settings[ 'usertype' ] )
          {
            case 'Registered': $registeredOption = 'selected'; break;
            case 'Author': $authorOption = 'selected'; break;
            case 'Editor': $editorOption = 'selected'; break;
            case 'Publisher': $publisherOption = 'selected'; break;
            case 'default':
            default: $userTypeDefaultOption = 'selected'; break;
          }
        ?>
        <label><?php echo JText::_( 'LABEL_OPTION_OVERRIDE_USER_TYPE' ) ?></label>
        <select name="usertype">
          <option value="default" <?php echo $userTypeDefaultOption; ?>><?php echo JText::sprintf( 'LABEL_OPTION_OVERRIDE_USER_TYPE_DEFAULT', $settings[ 'default_usertype' ] ) ?></option>
          <option value="Registered" <?php echo $registeredOption; ?>><?php echo JText::_( 'Registered' ) ?></option>
          <option value="Author" <?php echo $authorOption; ?>><?php echo JText::_( 'Author' ) ?></option>
          <option value="Editor" <?php echo $editorOption; ?>><?php echo JText::_( 'Editor' ) ?></option>
          <option value="Publisher" <?php echo $publisherOption; ?>><?php echo JText::_( 'Publisher' ) ?></option>
        </select>
      </p>
    <?php endif; ?>
    <?php if ( ( count( $options ) == 0 ) or in_array( 'block_activate', $options ) ): ?>
      <p>
      	<?php
          $blockActivateOption = '';
          $unblockActivateOption = '';
          $blockDeactivateOption = '';
          $defaultOption = 'selected';
      	?>
        <label><?php echo JText::_( 'LABEL_OPTION_OVERRIDE_BLOCK_ACTIVATE' ) ?></label>
        <select name="block_activate">
          <option value="default" <?php echo $defaultOption; ?>><?php echo JText::_( 'LABEL_OPTION_OVERRIDE_BLOCK_ACTIVATE_DEFAULT' ) ?></option>
          <option value="no_yes" <?php echo $unblockActivateOption; ?>><?php echo JText::_( 'LABEL_OPTION_OVERRIDE_BLOCK_ACTIVATE_NO_YES' ) ?></option>
          <option value="yes_yes" <?php echo $blockActivateOption; ?>><?php echo JText::_( 'LABEL_OPTION_OVERRIDE_BLOCK_ACTIVATE_YES_YES' ) ?></option>
          <option value="yes_no" <?php echo $blockDeactivateOption; ?>><?php echo JText::_( 'LABEL_OPTION_OVERRIDE_BLOCK_ACTIVATE_YES_NO' ) ?></option>
        </select>
      </p>
    <?php endif; ?>
    <?php if ( ( count( $options ) == 0) or in_array( 'dry_run', $options ) ): ?>
     	<br /><hr /><br />
     	<ul><li><label><?php echo JText::_( 'HELP_DRY_RUN' ) ?></label></li></ul>
      <p>
        <?php
          $yesOption = 'checked';
          $noOption = '';
        ?>
        <label><?php echo JText::_( 'LABEL_OPTION_DRY_RUN' ) ?></label>
        <input type="radio" name="dry_run" id="dry_run_yes" value="1" <?php echo $yesOption; ?>/>
        <label for="dry_run_yes"><?php echo JText::_( 'YES' ) ?></label>
        <input type="radio" name="dry_run" id="dry_run_no" value="0" <?php echo $noOption; ?> />
        <label for="dry_run_no"><?php echo JText::_( 'NO' ) ?></label>
      </p>
      <p>
        <label><?php echo JText::_( 'LABEL_OPTION_DRY_RUN_EMAIL' ) ?></label>
        <input type="email" name="dry_run_email" id="dry_run_email" size="80"
            value="<?php echo $settings[ 'dry_run_email' ]; ?>"/>
      </p>
      <br /><hr /><br />
    <?php endif; ?>
    <?php if ( ( count( $options ) == 0) or in_array( 'notify_user', $options ) ): ?>
    	<?php
    	  global $mainframe;
    	  $admin =& JFactory::getUser();
    	  $activationUrl = JURI::root() . "index.php?option=com_user&task=activate&activation=";
    	?>
      <p>
        <?php
          $yesOption = $settings[ 'notify_user' ] ? 'checked' : '';
          $noOption = $settings[ 'notify_user' ] ? '' : 'checked';
          $emailSubject = $settings[ 'email_subject' ];
          $emailBody = $settings[ 'email_body' ];
        ?>
        <label><?php echo JText::_( 'LABEL_OPTION_NOTIFY_USER' ) ?></label>
        <input type="radio" name="notify_user" id="notify_user_yes" value="1" <?php echo $yesOption; ?>/>
        <label for="notify_user_yes"><?php echo JText::_( 'YES' ) ?></label>
        <input type="radio" name="notify_user" id="notify_user_no" value="0" <?php echo $noOption; ?> />
        <label for="notify_user_no"><?php echo JText::_( 'NO' ) ?></label>
      </p>
        <label><?php echo JText::_( 'LABEL_OPTION_EMAIL_SUBJECT' ) ?></label>
        <input type="text" name="email_subject" id="email_subject" size="80"
          value="<?php echo $emailSubject; ?>"/>
      </p>
      <p>
        <label><?php echo JText::_( 'LABEL_OPTION_EMAIL_BODY' ) ?></label>
        <textarea class="text_area" name="email_body" id="email_body" cols="80" rows="10"><?php
          echo $emailBody;
        ?></textarea>
      </p>
      <ul>
      	<li><label><?php echo JText::_( 'HELP_EMAIL_1' ); ?></label></li>
      	<li><label><?php echo JText::_( 'HELP_EMAIL_2' ); ?></label></li>
      	<?php if ( JString::strlen( $settings[ 'bcc' ] ) > 0 ): ?>
      		<li><label><?php echo JText::sprintf( 'HELP_EMAIL_3', $settings[ 'bcc' ] ); ?></label></li>
      	<?php endif; ?>
      	<br />
      	<li><label><?php echo JText::_( 'HELP_EMAIL_4' ); ?></label></li>
      	<br />
      	<li><label><?php echo JText::sprintf( 'HELP_EMAIL_5', implode( ', ', JUserportHelper::UserTypes() ),
      	    $mainframe->getCfg( 'sitename' ), JURI::root(), $admin->name, $admin->email, $activationUrl ); ?>
      	    </label></li>
      </ul>
    <?php endif; ?>
    <?php
  }

  /**
   * Prints out all the informational messages that have been gathered thus far.
   * The output is presented as a bulleted list, with formatting to easily
   * distinguish the different types of messages.
   * Also, a summary is printed out, formatted by Joomla's Message Application
   * Queue.
   * It can be that this function does not print anything at all; or only some
   * application messages; or only a bulleted list. This depends on the
   * availability of the different accepted types. Note that this function will
   * never print a form.
   * @param $title string The title used just above the printout of all
   * logitems.
   * @param $log array of arrays. Each unnamed index is an array with two
   * enforced unnamed indices: the first (index 0) leads to a string indicating
   * the type, the second (index 1) leads to a string with the actual message
   * The type must be one of: info, warning, error, line_success, line_ignored,
   * line_error. The former three are only printed out in Joomla's Message
   * Application Queue. The latter three are printed out as a formatted bulleted
   * list, and a summary in Joomla's Message Application Queue.
   * Other types are ignored and not printed out.
   * @return void
   */
  function PrintLog( $title, & $log )
  {
    $appMessage = array
    ( 'info'=>array( ),
      'warning'=>array( ),
      'error'=>array( ),
      'line_success'=>array( 'count'=>0 ),
      'line_ignored'=>array( 'count'=>0 ),
      'line_error'=>array( 'count'=>0 ));
    $formatData = array
    ( 'info'=>array( 'font'=>"<font color='gray'>"),
      'warning'=>array( 'font'=>"<font color='black'>"),
      'error'=>array( 'font'=>"<font color='red' size='+1'>"),
      'line_success'=>array( 'font'=>"<font color='green'>"),
      'line_ignored'=>array( 'font'=>"<font color='black'>"),
      'line_error'=>array( 'font'=>"<font color='red' size='+1'>"));
    $printLogString = false;

    $logString = "";
    $logString .= "<ul>";
    foreach ( $log as $logItem )
    {
      if ( in_array( $logItem[0], array( 'info', 'warning', 'error' ) ) )
      {
        $appMessage[ $logItem[0] ][] = $logItem[1];
      }

      if ( in_array( $logItem[0], array( 'line_success', 'line_ignored', 'line_error' ) ) )
      {
        $appMessage[ $logItem[0] ][ 'count' ]++;
        $logString .= "<li>".$formatData[ $logItem[0] ]['font'];
        $logString .= "$logItem[1]";
        $logString .= "</font></li>";
        $printLogString = true;
      }
    }
    $logString .= "</ul>";

    JUserportHtml::_PrintApplicationMessages( $appMessage );

    if ( $printLogString == true )
    {
      ?>
      <fieldset class="adminForm">
        <legend><?php echo $title; ?></legend>
        <p><?php echo $logString; ?></p>
      </fieldset>
      <?php
    }
  }

  function PrintHelp()
  {
    $siteUrl = 'http://joomlacode.org/gf/project/userport/';
    $bugUrl = $siteUrl . 'tracker/?action=TrackerItemBrowse&tracker_id=7775';
    $featureUrl = $siteUrl . 'tracker/?action=TrackerItemBrowse&tracker_id=7774';
    $donateUrl = 'https://www.paypal.com/cgi-bin/webscr?cmd=_s-xclick&hosted_button_id=HJ3JXETP36JUC';

    echo JText::_( 'HELP_ABOUT_1' );
    echo JText::sprintf( 'HELP_ABOUT_2', $siteUrl );
    echo JText::_( 'HELP_TASK_OVERVIEW_BEGIN' );
    echo JText::sprintf( 'HELP_TASK_OVERVIEW_VIEW', JText::_( 'BUTTON_EXPORT') );
    echo JText::sprintf( 'HELP_TASK_OVERVIEW_ADD', JText::_( 'BUTTON_CHOOSE_INTIAL_TEXT' ), JText::_( 'BUTTON_SHOW_EDIT_WINDOW' ), JText::_( 'BUTTON_ADD' ), JText::_( 'BUTTON_ADD' ) );
    echo JText::sprintf( 'HELP_TASK_OVERVIEW_UPDATE', JText::_( 'BUTTON_CHOOSE_INTIAL_TEXT' ), JText::_( 'BUTTON_SHOW_EDIT_WINDOW' ), JText::_( 'BUTTON_UPDATE' ), JText::_( 'BUTTON_UPDATE' ) );
    echo JText::sprintf( 'HELP_TASK_OVERVIEW_DELETE', JText::_( 'BUTTON_CHOOSE_INTIAL_TEXT' ), JText::_( 'BUTTON_DELETE' ) );
    echo JText::_( 'HELP_TASK_OVERVIEW_END' );
    echo JText::sprintf( 'HELP_CLOSURE', $bugUrl, $featureUrl, $donateUrl );
  }

  /**
   * Prints out application messages which appear on top of the page, rendered
   * by Joomla's framework.
   * @param $appMessage array of mixed type.
   * Acceptable indices are info, warning, error, line_success, line_ignored
   * and line_error.
   * Each element is
   * - either an array with one enforced index: count which must be an integer
   *   (line_success, line_ignored, line_error),
   * - either an unnamed array of strings
   *   (info, warning, error).
   * @return void
   * @access private
   */
  function _PrintApplicationMessages( & $appMessage )
  {
    $noticeFormat = array
    ( 'info'=>array
      ( 'type'=>'message' ),
      'warning'=>array
      ( 'type'=>'notice' ),
      'error'=>array
      ( 'type'=>'error' ) );

    $statFormat = array
    ( 'line_success'=>array
      ( 1=>array
        ( 'text' => JText::_( 'LOG_1_ACCEPTED_LINE' ),
          'type'=>'message' ),
        'N'=>array
        ( 'text' => JText::sprintf( 'LOG_N_ACCEPTED_LINES', $appMessage[ 'line_success' ][ 'count' ] ),
          'type'=>'message' ) ),
      'line_ignored'=>array
      ( 1=>array
        ( 'text' => JText::_( 'LOG_1_IGNORED_LINE' ),
          'type'=>'notice' ),
        'N'=>array
        ( 'text' => JText::sprintf( 'LOG_N_IGNORED_LINES', $appMessage[ 'line_ignored' ][ 'count' ] ),
          'type'=>'notice' ) ),
      'line_error'=>array
      ( 1=>array
        ( 'text' => JText::_( 'LOG_1_ERROR_LINE' ),
          'type'=>'error' ),
        'N'=>array
        ( 'text' => JText::sprintf( 'LOG_N_ERROR_LINES', $appMessage[ 'line_error' ][ 'count' ] ),
          'type'=>'error' ) ) );

    $app = JFactory::getApplication();

    foreach ( array( 'line_success', 'line_ignored', 'line_error' ) as $key )
    {
     if ( ( key_exists( $key, $appMessage ) )
       and ( key_exists( 'count', $appMessage[ $key ] ) ) )
     {
        if ( $appMessage[ $key ][ 'count' ] != 0 )
        {
          if ($appMessage[ $key ][ 'count' ] > 1)
          {
            $appMessage[ $key ][ 'count' ] = 'N';
          }
          $index = $appMessage[ $key ][ 'count' ];
          $message = $statFormat[ $key ][ $index ][ 'text' ];
          $type = $statFormat[ $key ][ $index ]['type'];
          $app->enqueueMessage($message, $type);
        }
      }
    }

    foreach ( array( 'info', 'warning', 'error' ) as $key )
    {
     if ( key_exists( $key, $appMessage ) )
     {
        foreach ( $appMessage[ $key ] as $message )
        {
          $type = $noticeFormat[ $key ]['type'];
          $app->enqueueMessage($message, $type);
        }
      }
    }
  }
}

?>
